'use strict';

var _inherits = require('babel-runtime/helpers/inherits')['default'];

var _get = require('babel-runtime/helpers/get')['default'];

var _createClass = require('babel-runtime/helpers/create-class')['default'];

var _classCallCheck = require('babel-runtime/helpers/class-call-check')['default'];

var _Object$defineProperty = require('babel-runtime/core-js/object/define-property')['default'];

_Object$defineProperty(exports, '__esModule', {
  value: true
});

var _react = require('react');

var reduxShape = _react.PropTypes.shape({
  subscribe: _react.PropTypes.func.isRequired,
  dispatch: _react.PropTypes.func.isRequired,
  getState: _react.PropTypes.func.isRequired
});

var Provider = (function (_Component) {
  function Provider(props, context) {
    _classCallCheck(this, Provider);

    _get(Object.getPrototypeOf(Provider.prototype), 'constructor', this).call(this, props, context);
    this.state = { redux: props.redux };
  }

  _inherits(Provider, _Component);

  _createClass(Provider, [{
    key: 'getChildContext',
    value: function getChildContext() {
      return { redux: this.state.redux };
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var nextDispatcher = nextProps.redux.getDispatcher();
      this.state.redux.replaceDispatcher(nextDispatcher);
    }
  }, {
    key: 'render',
    value: function render() {
      var children = this.props.children;

      return children();
    }
  }], [{
    key: 'propTypes',
    value: {
      redux: reduxShape.isRequired,
      children: _react.PropTypes.func.isRequired
    },
    enumerable: true
  }, {
    key: 'childContextTypes',
    value: {
      redux: reduxShape.isRequired
    },
    enumerable: true
  }]);

  return Provider;
})(_react.Component);

exports['default'] = Provider;
module.exports = exports['default'];