'use strict';

var _Object$defineProperty = require('babel-runtime/core-js/object/define-property')['default'];

_Object$defineProperty(exports, '__esModule', {
  value: true
});

exports['default'] = createDispatcher;

function createDispatcher(store) {
  return function dispatcher(initialState, setState) {
    var state = store(initialState, {});
    setState(state);

    function dispatchSync(action) {
      state = store(state, action);
      setState(state);
      return action;
    }

    function dispatch(action) {
      return typeof action === 'function' ? action(dispatch, state) : dispatchSync(action);
    }

    return dispatch;
  };
}

module.exports = exports['default'];